function loadExplosions()
	MAX_TIME = 2
	explosions = {}
	sprite = love.graphics.newImage('sprite_crushed.png')
	math.randomseed(os.time())
end

function drawExplosions()
	for _,this in ipairs(explosions) do
		for i=1, #this.puffs do
			local me = this.puffs[i]
			if i <= this.tallies[1] then
				love.graphics.setColor(255, 96, 48, this.alpha)
			elseif i <= this.tallies[2] + this.tallies[1] then
				love.graphics.setColor(255, 128, 64, this.alpha)
			else
				alpha = math.max(0, this.alpha - (this.timer * 511))
				love.graphics.setColor(255, 192, 0, alpha)
			end
			love.graphics.draw(sprite, this.x + me.x, this.y + me.y, me.rotation, me.scale, me.scale, 32, 32)
		end
	end
	--love.graphics.setColor(255, 255, 255, 255)
	--love.graphics.print(love.timer.getFPS(), 8, 8)
end

function updateExplosions(dt)
	for i = #explosions, 1, -1 do
		local this = explosions[i]
		for i=1, #explosions[i].puffs do
			local me = this.puffs[i]
			me.rotation = me.rotation + (dt * me.speed)
			me.speed = me.speed - dt
			me.scale = me.scale + (dt / 2)
			if this.timer < MAX_TIME / 8 then
				local move = (2 - this.timer) * dt
				me.x = me.x + (me.x * move * me.thurst)
				me.y = me.y + (me.y * move * me.thurst)
				me.scale = me.scale + (dt / 2)
			end
		end
		if this.timer > 3 * (MAX_TIME / 4) then
			this.alpha = this.alpha - (dt * 511)
		end
		this.timer = this.timer + dt
		if this.timer > MAX_TIME then
			table.remove(explosions, i)
		end
	end
end

function newExplosion(x, y)
	local data = {
		timer = 0,
		x = x,
		y = y,
		alpha = 255,
		tallies = {},
		puffs = {}
	}
	local sets = {
		{24, 36, 30, 40, 50, 3, 1},
		{48, 64, 0, 30, 100, 2, 1},
		{12, 16, 20, 40, 75, 2, 4}
	}
	for i=1, #sets do
		local count = math.random(sets[i][1], sets[i][2])
		data.tallies[i] = count
		local angle_per = 360 / count
		for j=1, count do
			local puff = newPuff((j * angle_per), {sets[i][3], sets[i][4]}, sets[i][5], sets[i][6], sets[i][7])
			table.insert(data.puffs, puff)
		end
	end
	table.insert(explosions, data)
end

function newPuff(angle, hyp, size, spin, zoom)
	angle = angle - math.random(5)
	length = math.random(hyp[1], hyp[2])
	return {
		x = math.sin(angle) * length,
		y = math.cos(angle) * length,
		rotation = math.random(0, 359),
		scale = math.random(5) / size,
		speed = math.random() * spin + 2,
		thurst = zoom
	}
end